<?php // $Id: resource.class.php,v 1.21.14.1 2006/10/23 13:41:28 moodler Exp $

class resource_ref extends resource_base {


    function resource_ref($cmid=0) {
       parent::resource_base($cmid);
    }
    
    //file
    var $parameters;
    var $maxparameters = 5;

    // file function copy 
    /**
    * Sets the parameters property of the extended class
    *
    * Sets the parameters property of the extended file resource class
    *
    * @param    USER  global object
    * @param    CFG   global object
    */
    function set_parameters() {
        global $USER, $CFG;

        if (! empty($this->course->lang)) {
            $CFG->courselang = $this->course->lang;
        }

        $site = get_site();

        $this->parameters = array(
            'label2'          => array('langstr' => "",
                                       'value'   =>'/optgroup'),
            'label3'          => array('langstr' => get_string('course'),
                                       'value'   => 'optgroup'),

            'courseid'        => array('langstr' => 'id',
                                       'value'   => $this->course->id),
            'coursefullname'  => array('langstr' => get_string('fullname'),
                                       'value'   => $this->course->fullname),
            'courseshortname' => array('langstr' => get_string('shortname'),
                                       'value'   => $this->course->shortname),
            'courseidnumber'  => array('langstr' => get_string('idnumbercourse'),
                                       'value'   => $this->course->idnumber),
            'coursesummary'   => array('langstr' => get_string('summary'),
                                       'value'   => $this->course->summary),
            'courseformat'    => array('langstr' => get_string('format'),
                                       'value'   => $this->course->format),
            'courseteacher'   => array('langstr' => get_string('wordforteacher'),
                                       'value'   => $this->course->teacher),
            'courseteachers'  => array('langstr' => get_string('wordforteachers'),
                                       'value'   => $this->course->teachers),
            'coursestudent'   => array('langstr' => get_string('wordforstudent'),
                                       'value'   => $this->course->student),
            'coursestudents'  => array('langstr' => get_string('wordforstudents'),
                                       'value'   => $this->course->students),

            'label4'          => array('langstr' => "",
                                       'value'   =>'/optgroup'),
            'label5'          => array('langstr' => get_string('miscellaneous'),
                                       'value'   => 'optgroup'),

            'lang'            => array('langstr' => get_string('preferredlanguage'),
                                       'value'   => current_language()),
            'sitename'        => array('langstr' => get_string('fullsitename'),
                                       'value'   => $site->fullname),
            'serverurl'       => array('langstr' => get_string('serverurl', 'resource', $CFG),
                                       'value'   => $CFG->wwwroot),
            'currenttime'     => array('langstr' => get_string('time'),
                                       'value'   => time()),
            'encryptedcode'   => array('langstr' => get_string('encryptedcode'),
                                       'value'   => $this->set_encrypted_parameter()),

            'label6'          => array('langstr' => "",
                                       'value'   =>'/optgroup')
	);

    if (!empty($USER->id)) {

        $userparameters = array(

            'label1'          => array('langstr' => get_string('user'),
                                       'value'   => 'optgroup'),

            'userid'          => array('langstr' => 'id',
                                       'value'   => $USER->id),
            'userusername'    => array('langstr' => get_string('username'),
                                       'value'   => $USER->username),
            'useridnumber'    => array('langstr' => get_string('idnumber'),
                                       'value'   => $USER->idnumber),
            'userfirstname'   => array('langstr' => get_string('firstname'),
                                       'value'   => $USER->firstname),
            'userlastname'    => array('langstr' => get_string('lastname'),
                                       'value'   => $USER->lastname),
            'userfullname'    => array('langstr' => get_string('fullname'),
                                       'value'   => fullname($USER)),
            'useremail'       => array('langstr' => get_string('email'),
                                       'value'   => $USER->email),
            'usericq'         => array('langstr' => get_string('icqnumber'),
                                       'value'   => $USER->icq),
            'userphone1'      => array('langstr' => get_string('phone').' 1',
                                       'value'   => $USER->phone1),
            'userphone2'      => array('langstr' => get_string('phone').' 2',
                                       'value'   => $USER->phone2),
            'userinstitution' => array('langstr' => get_string('institution'),
                                       'value'   => $USER->institution),
            'userdepartment'  => array('langstr' => get_string('department'),
                                       'value'   => $USER->department),
            'useraddress'     => array('langstr' => get_string('address'),
                                       'value'   => $USER->address),
            'usercity'        => array('langstr' => get_string('city'),
                                       'value'   => $USER->city),
            'usertimezone'    => array('langstr' => get_string('timezone'),
                                       'value'   => get_user_timezone_offset()),
            'userurl'         => array('langstr' => get_string('webpage'),
                                       'value'   => $USER->url)
        );

        $this->parameters = array_merge($userparameters, $this->parameters);
	
        }
    }


    function update_instance($resource) {
    // Given an object containing all the necessary data, 
    // (defined by the form in mod.html) this function 
    // will update an existing instance with new data.

        global $RESOURCE_WINDOW_OPTIONS;

        //reference path check
        if (!$refertext = get_record('resource','id',$resource->reference)) {
            error(get_string('referresourcedel', 'resource'),$CFG->wwwroot.'/course/view.php?id='.$resource->course);
        }
        //resource->type 
        $refertype = $refertext->type;

        //
        $resource->id = $resource->instance;
        $resource->timemodified = time();

        if ($refertype == 'html' || $refertype == 'tree') {

	    if (isset($resource->windowpopup)) {
	        $optionlist = array();
	        foreach ($RESOURCE_WINDOW_OPTIONS as $option) {
	            if (isset($resource->$option)) {
	                $optionlist[] = $option."=".$resource->$option;
	            }
	        }
	        $resource->popup = implode(',', $optionlist);

	    } else if (isset($resource->windowpage)) {
	        $resource->popup = "";
	    }

	    if (isset($resource->blockdisplay)) {
	        $resource->options = 'showblocks';
	    } else {
	        $resource->options = '';
	    }

	    if (isset($resource->parametersettingspref)) {
	        set_user_preference('resource_parametersettingspref', $resource->parametersettingspref);
	    }
	    if (isset($resource->windowsettingspref)) {
	        set_user_preference('resource_windowsettingspref', $resource->windowsettingspref);
	    }

	    return update_record("resource", $resource);

        } elseif ($refertype == 'text') {

	    if (isset($resource->windowpopup)) {
	        $optionlist = array();
	        foreach ($RESOURCE_WINDOW_OPTIONS as $option) {
	            if (isset($resource->$option)) {
	                $optionlist[] = $option."=".$resource->$option;
	            }
	        }
	        $resource->popup = implode(',', $optionlist);

	    } else if (isset($resource->windowpage)) {
	        $resource->popup = "";
            }

	    if (isset($resource->blockdisplay)) {
	        $resource->options = 'showblocks';
	    }

            if (isset($resource->parametersettingspref)) {
	        set_user_preference('resource_parametersettingspref', $resource->parametersettingspref);
	    }
	    if (isset($resource->windowsettingspref)) {
                 set_user_preference('resource_windowsettingspref', $resource->windowsettingspref);
            }

            return update_record("resource", $resource);

        } else if($refertype == 'file') {
	    $optionlist = array();

	    for ($i = 0; $i < $this->maxparameters; $i++) {
	        $parametername = "parameter$i";
	        $parsename = "parse$i";
	        if (!empty($resource->$parsename) and $resource->$parametername != "-") {
	            $optionlist[] = $resource->$parametername."=".$resource->$parsename;
	        }
	    }
            
	    $resource->alltext = implode(',', $optionlist);
	    // frame
	    if ($resource->options == 'frame') {
	        $resource->framepage = 'frame';
	    }
	    return parent::update_instance($resource);

	} else if($refertype == 'directory') {
	    //var_dump($resource);
	    return parent::update_instance($resource);
	}
    }

    function display() {
        global $CFG, $THEME;
        
	//tree use resource->id
        $rsid = optional_param( 'rsid' );
	//type check
	$resource  = $this->resource;
	
	//reference was deleted
	if (!$refertext = get_record('resource','id',$resource->reference)) {
	    error(get_string('referresourcedel', 'resource'),$CFG->wwwroot.'/course/view.php?id='.$resource->course);
        }
        $refertype = $refertext->type;

        if ($refertype == 'html') {

            /// Are we displaying the course blocks?
            if ($this->resource->options == 'showblocks') {

                parent::display_course_blocks_start();

                $formatoptions->noclean = true;

	        if ($text = str_replace("/file.php/","/mod/resource/type/ref/refer_file.php/",$refertext->alltext)){
	            $refertext->alltext = $text;
	        }
                echo format_text($refertext->alltext, FORMAT_HTML, $formatoptions, $this->course->id);

                parent::display_course_blocks_end();

            } else {

	        /// Set up generic stuff first, including checking for access
	        parent::display();

                /// Set up some shorthand variables
	        $cm = $this->cm;
                $course    = $this->course;
                $resource  = $this->resource;
	        $refertext = get_record('resource','id',$resource->reference);

                $pagetitle = strip_tags($course->shortname.': '.format_string($resource->name));
                $formatoptions->noclean = true;
                $inpopup_param = optional_param( 'inpopup','' );
                $inpopup = !empty($inpopup_param);
                //摜file.php -> refer_file.php
	        if ($text = str_replace("/file.php/","/mod/resource/type/ref/refer_file.php/",$refertext->alltext)){
	            $refertext->alltext = $text;
	        }

                if ($resource->popup) {
                    if ($inpopup) {                    /// Popup only
                        add_to_log($course->id, "resource", "view", "view.php?id={$cm->id}", $resource->id, $cm->id);
                        print_header();
                        print_simple_box(format_text($refertext->alltext, FORMAT_HTML, $formatoptions, $course->id), 
                                        "center", "", "", "20");
                        print_footer($course);
                    } else {                           /// Make a page and a pop-up window

                        print_header($pagetitle, $course->fullname, "$this->navigation ".format_string($resource->name), 
                                    "", "", true, update_module_button($cm->id, $course->id, $this->strresource), 
                                    navmenu($course, $cm));

	                echo "\n<script language=\"javascript\" type=\"text/javascript\">";
	                echo "\n<!--\n";
	                echo "openpopup('/mod/resource/view.php?inpopup=true&id={$cm->id}','resource{$resource->id}','{$resource->popup}');\n";
	                echo "\n-->\n";
	                echo '</script>';
	                if (trim(strip_tags($resource->summary))) {
	                    print_simple_box(format_text($resource->summary, FORMAT_MOODLE, $formatoptions, $course->id), "center");
	                }
		        $link = "<a href=\"$CFG->wwwroot/mod/resource/view.php?inpopup=true&amp;id={$cm->id}\" target=\"resource{$resource->id}\" onclick=\"return openpopup('/mod/resource/view.php?inpopup=true&amp;id={$cm->id}', 'resource{$resource->id}','{$resource->popup}');\">".format_string($resource->name,true)."</a>";

	                echo "<p>&nbsp;</p>";
	                echo '<p align="center">';
	                print_string('popupresource', 'resource');
	                echo '<br />';
	                print_string('popupresourcelink', 'resource', $link);
	                echo "</p>";

	                print_footer($course);
                    }
                
                } else {    /// not a popup at all

                    add_to_log($course->id, "resource", "view", "view.php?id={$cm->id}", $resource->id, $cm->id);
                    print_header($pagetitle, $course->fullname, "$this->navigation ".format_string($resource->name),
                             "", "", true, update_module_button($cm->id, $course->id, $this->strresource), 
                            navmenu($course, $cm));

                    print_simple_box(format_text($refertext->alltext, FORMAT_HTML, $formatoptions, $course->id), "center", "", "", "20");

                    $strlastmodified = get_string("lastmodified");
                    echo "<center><p><font size=\"1\">$strlastmodified: ".userdate($resource->timemodified)."</font></p></center>";

                    print_footer($course);
                }

            }
    
        } else if ($refertype == 'text') {
            /// Are we displaying the course blocks?
            if ($this->resource->options == 'showblocks') {

                parent::display_course_blocks_start();

                $formatoptions->noclean = true;
        
                if (trim(strip_tags($this->resource->summary))) {
                    echo format_text($this->resource->summary, FORMAT_MOODLE, $formatoptions, $this->course->id);
                }

                parent::display_course_blocks_end();

            } else {

                /// Set up generic stuff first, including checking for access
                parent::display();

                /// Set up some shorthand variables
                $cm = $this->cm;     
                $course = $this->course;
                $resource = $this->resource; 

                $pagetitle = strip_tags($course->shortname.': '.format_string($resource->name));
	        $formatoptions->noclean = true;
	        $inpopup_param = optional_param( 'inpopup', '' );
	        $inpopup = !empty($inpopup_param);

	        //摜file.php -> refer_file.php
	        if ($text = str_replace("/file.php/","/mod/resource/type/ref/refer_file.php/",$refertext->alltext)){
	            $refertext->alltext = $text;
	        }

	        if ($resource->popup) {
	            if ($inpopup) {                    /// Popup only
	                add_to_log($course->id, "resource", "view", "view.php?id={$cm->id}", 
	                        $resource->id, $cm->id);
	                print_header();
	                print_simple_box(format_text($refertext->alltext, $resource->options, $formatoptions, $course->id), 
	                        "center", "", "", "20");
	                print_footer($course);
	            } else {                           /// Make a page and a pop-up window

	                print_header($pagetitle, $course->fullname, "$this->navigation ".format_string($resource->name), 
	                        "", "", true, update_module_button($cm->id, $course->id, $this->strresource), 
	                        navmenu($course, $cm));

	                echo "\n<script language=\"javascript\" type=\"text/javascript\">";
	                echo "\n<!--\n";
	                echo "openpopup('/mod/resource/view.php?inpopup=true&id={$cm->id}','resource{$resource->id}','{$resource->popup}');\n";
	                echo "\n-->\n";
	                echo '</script>';

	                if (trim(strip_tags($resource->summary))) {
	                    print_simple_box(format_text($resource->summary, FORMAT_MOODLE, $formatoptions, $course->id), "center");
	                }

	                $link = "<a href=\"$CFG->wwwroot/mod/resource/view.php?inpopup=true&amp;id={$cm->id}\" target=\"resource{$resource->id}\" onclick=\"return openpopup('/mod/resource/view.php?inpopup=true&amp;id={$cm->id}', 'resource{$resource->id}','{$resource->popup}');\">".format_string($resource->name,true)."</a>";

	                echo "<p>&nbsp;</p>";
	                echo '<p align="center">';
	                print_string('popupresource', 'resource');
	                echo '<br />';
	                print_string('popupresourcelink', 'resource', $link);
	                echo "</p>";

	                print_footer($course);
	            }
	        } else {    /// not a popup at all

	            add_to_log($course->id, "resource", "view", "view.php?id={$cm->id}", $resource->id, $cm->id);
	            print_header($pagetitle, $course->fullname, "$this->navigation ".format_string($resource->name),
	                    "", "", true, update_module_button($cm->id, $course->id, $this->strresource), 
	                    navmenu($course, $cm));

	            print_simple_box(format_text($refertext->alltext, $resource->options, $formatoptions, $course->id), 
	                   "center", "", "", "20");

	            $strlastmodified = get_string("lastmodified");
	            echo "<center><p><font size=\"1\">$strlastmodified: ".userdate($resource->timemodified)."</font></p></center>";

	            print_footer($course);
	        }

	    }
    
	} else if ($refertype == 'directory') {
            /// Set up generic stuff first, including checking for access
            parent::display();

            /// Set up some shorthand variables
            //var_dump($this);
            //var_dump($resource);
    
            $cm = $this->cm;
            $course = $this->course;
            $resource = $this->resource; 

            require_once($CFG->libdir.'/filelib.php');

            $subdir = optional_param( 'subdir','' ); 

            add_to_log($course->id, "resource", "view", "view.php?id={$cm->id}", $resource->id, $cm->id);


        if ($refertext->reference) {
            if (detect_munged_arguments($refertext->reference, 0)) {
                error("The filename contains illegal characters!");
            }
	    $relativepath = "{$refertext->course}/{$refertext->reference}";
        } else {
            $relativepath = "{$refertext->course}";
        }

        if ($subdir) {
            if (detect_munged_arguments($subdir, 0)) {
                error("The value for 'subdir' contains illegal characters!");
            }
            $relativepath = "$relativepath$subdir";
            if (stripos($relativepath, 'backupdata') !== FALSE or stripos($relativepath, $CFG->moddata) !== FALSE) {
                error("Access not allowed!");
            }

            $subs = explode('/', $subdir);
            array_shift($subs);
            $countsubs = count($subs);
            $count = 0;
            $subnav = "<a href=\"view.php?id={$cm->id}\">".format_string($resource->name,true)."</a>";
            $backsub = '';
            foreach ($subs as $sub) {
                $count++;
                if ($count < $countsubs) {
                    $backsub .= "/$sub";
                    $subnav  .= " -> <a href=\"view.php?id={$cm->id}&amp;subdir=$backsub\">$sub</a>";
                } else {
                    $subnav .= " -> $sub";
                }
            }
        } else {
            $subnav = format_string($resource->name);
        }

        $pagetitle = strip_tags($course->shortname.': '.format_string($resource->name));

        print_header($pagetitle, $course->fullname, "$this->navigation $subnav",
                "", "", true, update_module_button($cm->id, $course->id, $this->strresource),
                navmenu($course, $cm));

        if (trim(strip_tags($resource->summary))) {
            $formatoptions->noclean = true;
            print_simple_box(format_text($resource->summary, FORMAT_MOODLE, $formatoptions, $course->id), "center");
            print_spacer(10,10);
        }

        $files = get_directory_list("$CFG->dataroot/$relativepath", array($CFG->moddata, 'backupdata'), false, true, true);


        if (!$files) {
            print_heading(get_string("nofilesyet"));
            print_footer($course);
            exit;
        }

        print_simple_box_start("center", "", "", '0' );

        $strftime = get_string('strftimedatetime');
        $strname = get_string("name");
        $strsize = get_string("size");
        $strmodified = get_string("modified");

        echo '<table cellpadding="4" cellspacing="1" class="files">';
        echo "<tr><th colspan=\"2\" class=\"header name\">$strname</th>".
             "<th align=\"right\" colspan=\"2\" class=\"header size\">$strsize</th>".
             "<th align=\"right\" class=\"header date\">$strmodified</th>".
             "</tr>";
        foreach ($files as $file) {
            if (is_dir("$CFG->dataroot/$relativepath/$file")) {          // Must be a directory
                $icon = "folder.gif";
                $relativeurl = "/view.php?blah";
                $filesize = display_size(get_directory_size("$CFG->dataroot/$relativepath/$file"));

            } else {
                $icon = mimeinfo("icon", $file);

                if ($CFG->slasharguments) {
                    $relativeurl = "/mod/resource/type/ref/refer_file.php/$relativepath/$file";
                } else {
                    $relativeurl = "/mod/resource/type/ref/refer_file.php?file=/$relativepath/$file";
                }
                $filesize = display_size(filesize("$CFG->dataroot/$relativepath/$file"));
            }

            if ($icon == 'folder.gif') {
                echo '<tr class="folder"><td>';
                echo "<img src=\"$CFG->pixpath/f/$icon\" width=\"16\" height=\"16\" alt=\"\"/>";
                echo '</td>';
                echo '<td nowrap="nowrap" class="name">';
                echo "<a href=\"view.php?id={$cm->id}&amp;subdir=$subdir/$file\">$file</a>";
            } else {
                echo '<tr class="file"><td>';
                echo "<img src=\"$CFG->pixpath/f/$icon\" width=\"16\" height=\"16\" alt=\"\"/>";
                echo '</td>';
                echo '<td nowrap="nowrap" class="name">';
                link_to_popup_window($relativeurl, "resourcedirectory{$resource->id}", "$file", 450, 600, '');
            }
            echo '</td>';
            echo '<td>&nbsp;</td>';
            echo '<td align="right" nowrap="nowrap" class="size">';
            echo $filesize;
            echo '</td>';
            echo '<td align="right" nowrap="nowrap" class="date">';
            echo userdate(filemtime("$CFG->dataroot/$relativepath/$file"), $strftime);
            echo '</td>';
            echo '</tr>';
        }
        echo '</table>';

        print_simple_box_end();

        print_footer($course);

    } else if ($refertype == 'file') {
    
        /// Set up generic stuff first, including checking for access
        parent::display();

        /// Set up some shorthand variables
        $cm = $this->cm;
        $course = $this->course;
        $resource = $this->resource;


        $this->set_parameters(); // set the parameters array

    ///////////////////////////////////////////////

    /// Possible display modes are:
    /// File displayed in a frame in a normal window
    /// File displayed embedded in a normal page
    /// File displayed in a popup window
    /// File displayed emebedded in a popup window


        /// First, find out what sort of file we are dealing with.
        require_once($CFG->libdir.'/filelib.php');

        $querystring = '';
        $resourcetype = '';
        $embedded = false;
        $mimetype = mimeinfo("type", $refertext->reference);
        $pagetitle = strip_tags($course->shortname.': '.format_string($resource->name));

        if ($resource->options != "frame") {
            if (in_array($mimetype, array('image/gif','image/jpeg','image/png'))) {  // It's an image
                $resourcetype = "image";
                $embedded = true;

            } else if ($mimetype == "audio/mp3") {    // It's an MP3 audio file
                $resourcetype = "mp3";
                $embedded = true;

            } else if (substr($mimetype, 0, 10) == "video/x-ms") {   // It's a Media Player file
                $resourcetype = "mediaplayer";
                $embedded = true;

            } else if ($mimetype == "video/quicktime") {   // It's a Quicktime file
                $resourcetype = "quicktime";
                $embedded = true;

            } else if ($mimetype == "text/html") {    // It's a web page
                $resourcetype = "html";
            }
        }



    /// Form the parse string
        if (!empty($resource->alltext)) {
            $querys = array();
            $parray = explode(',', $resource->alltext);
            foreach ($parray as $fieldstring) {
                $field = explode('=', $fieldstring);
                $querys[] = urlencode($field[1]).'='.urlencode($this->parameters[$field[0]]['value']);
            }
            $querystring = implode('&', $querys);
        }


        /// Set up some variables

        $inpopup_param = optional_param( 'inpopup','' );
        $inpopup = !empty( $inpopup_param );

        if (resource_is_url($refertext->reference)) {
            $fullurl = $refertext->reference;
            if (!empty($querystring)) {
                $urlpieces = parse_url($refertext->reference);
                if (empty($urlpieces['query'])) {
                    $fullurl .= '?'.$querystring;
                } else {
                    $fullurl .= '&'.$querystring;
                }
            }

        } else if ($CFG->resource_allowlocalfiles and (strpos($refertext->reference, RESOURCE_LOCALPATH) === 0)) {  // Localpath
            $localpath = get_user_preferences('resource_localpath', 'D:');
            $relativeurl = str_replace(RESOURCE_LOCALPATH, $localpath, $refertext->reference);

            if ($querystring) {
                $relativeurl .= '?'.$querystring;
            }

            $relativeurl = str_replace('\\', '/', $relativeurl);
            $relativeurl = str_replace(' ', '%20', $relativeurl);
            $fullurl = 'file:///'.htmlentities($relativeurl);
            $localpath = true;

        } else {   // Normal uploaded file
            if ($CFG->slasharguments) {
		$relativeurl = "/mod/resource/type/ref/refer_file.php/{$refertext->course}/{$refertext->reference}";
                if ($querystring) {
                    $relativeurl .= '?'.$querystring;
                }
            } else {
		$relativeurl = "/mod/resource/type/ref/refer_file.php?file=/{$refertext->course}/{$refertext->reference}";
                if ($querystring) {
                    $relativeurl .= '&'.$querystring;
                }
            }
            $fullurl = "$CFG->wwwroot$relativeurl";
        }

        /// Print a notice and redirect if we are trying to access a file on a local file system
        /// and the config setting has been disabled
        if (!$CFG->resource_allowlocalfiles and (strpos($refertext->reference, RESOURCE_LOCALPATH) === 0)) {
            if ($inpopup) {
                print_header($pagetitle, $course->fullname);
            } else {
                print_header($pagetitle, $course->fullname, "$this->navigation ".format_string($resource->name), "", "", true, update_module_button($cm->id, $course->id, $this->strresource), navmenu($course, $cm));
            }
            notify(get_string('notallowedlocalfileaccess', 'resource', ''));
            if ($inpopup) {
                close_window_button();
            }
            print_footer('none');
            die;
        }


        /// Check whether this is supposed to be a popup, but was called directly

        if ($resource->popup and !$inpopup) {    /// Make a page and a pop-up window

            print_header($pagetitle, $course->fullname, "$this->navigation ".format_string($resource->name), "", "", true, update_module_button($cm->id, $course->id, $this->strresource), navmenu($course, $cm));


            echo "\n<script language=\"javascript\" type=\"text/javascript\">";
            echo "\n<!--\n";
            echo "openpopup('/mod/resource/view.php?inpopup=true&id={$cm->id}','resource{$resource->id}','{$resource->popup}');\n";
            echo "\n-->\n";
            echo '</script>';

            if (trim(strip_tags($resource->summary))) {
                $formatoptions->noclean = true;
                print_simple_box(format_text($resource->summary, FORMAT_MOODLE, $formatoptions), "center");
            }

            $link = "<a href=\"$CFG->wwwroot/mod/resource/view.php?inpopup=true&amp;id={$cm->id}\" target=\"resource{$resource->id}\" onclick=\"return openpopup('/mod/resource/view.php?inpopup=true&amp;id={$cm->id}', 'resource{$resource->id}','{$resource->popup}');\">".format_string($resource->name,true)."</a>";

            echo "<p>&nbsp;</p>";
            echo '<p align="center">';
            print_string('popupresource', 'resource');
            echo '<br />';
            print_string('popupresourcelink', 'resource', $link);
            echo "</p>";

            print_footer($course);
            exit;
        }


        /// Now check whether we need to display a frameset

        $frameset = optional_param( 'frameset','' );
        if (empty($frameset) and !$embedded and !$inpopup and ($resource->options == "frame")) {
            $encoding = current_charset();
            @header('Content-Type: text/html; charset='.$encoding);
            echo "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Frameset//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-frameset.dtd\">\n";
            echo "<html dir=\"ltr\">\n";
            echo '<head>';
            echo '<meta http-equiv="content-type" content="text/html; charset='.$encoding.'" />';
            echo "<title>{$course->shortname}: ".strip_tags(format_string($resource->name,true))."</title></head>\n";
            echo "<frameset rows=\"$CFG->resource_framesize,*\">";
            echo "<frame src=\"view.php?id={$cm->id}&amp;type={$resource->type}&amp;frameset=top\" />";
            if (!empty($localpath)) {  // Show it like this so we interpose some HTML
                echo "<frame src=\"view.php?id={$cm->id}&amp;type={$resource->type}&amp;inpopup=true\" />";
            } else {
                echo "<frame src=\"$fullurl\" />";
            }
            echo "</frameset>";
            echo "</html>";
            exit;
        }


        /// We can only get here once per resource, so add an entry to the log

        add_to_log($course->id, "resource", "view", "view.php?id={$cm->id}", $resource->id, $cm->id);


        /// If we are in a frameset, just print the top of it

        if (!empty( $frameset ) and ($frameset == "top") ) {
            print_header($pagetitle, $course->fullname, "$this->navigation ".format_string($resource->name), "", "", true, update_module_button($cm->id, $course->id, $this->strresource), navmenu($course, $cm, "parent"));

            $options->para = false;
            echo '<div class="summary">'.format_text($resource->summary, FORMAT_HTML, $options).'</div>';
            if (!empty($localpath)) {  // Show some help
                echo '<div align="right" class="helplink">';
                link_to_popup_window ('/mod/resource/type/file/localpath.php', get_string('localfile', 'resource'), get_string('localfilehelp','resource'), 400, 500, get_string('localfilehelp', 'resource'));
                echo '</div>';
            }
            echo '</body></html>';
            exit;
        }


        /// Display the actual resource

        if ($embedded) {       // Display resource embedded in page
            $strdirectlink = get_string("directlink", "resource");

            if ($inpopup) {
                print_header($pagetitle);
            } else {
                print_header($pagetitle, $course->fullname, "$this->navigation <a title=\"$strdirectlink\" target=\"$CFG->framename\" href=\"$fullurl\"> ".format_string($resource->name,true)."</a>", "", "", true, update_module_button($cm->id, $course->id, $this->strresource), navmenu($course, $cm, "self"));

            }

            if ($resourcetype == "image") {
                echo "<center><p>";
                echo "<img title=\"".strip_tags(format_string($resource->name,true))."\" class=\"resourceimage\" src=\"$fullurl\" alt=\"\" />";
                echo "</p></center>";

            } else if ($resourcetype == "mp3") {
                if (!empty($THEME->resource_mp3player_colors)) {
                    $c = $THEME->resource_mp3player_colors;   // You can set this up in your theme/xxx/config.php
                } else {
                    $c = 'bgColour=000000&btnColour=ffffff&btnBorderColour=cccccc&iconColour=000000&'.
                         'iconOverColour=00cc00&trackColour=cccccc&handleColour=ffffff&loaderColour=ffffff&'.
                         'font=Arial&fontColour=3333FF&buffer=10&waitForPlay=no&autoPlay=yes';
                }
                $c .= '&volText='.get_string('vol', 'resource').'&panText='.get_string('pan','resource');
                $c = htmlentities($c);
                echo '<div class="mp3player" align="center">';
                echo '<object classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000"';
                echo '        codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=6,0,0,0" ';
                echo '        width="600" height="70" id="mp3player" align="">';
                echo '<param name="movie" value="'.$CFG->wwwroot.'/lib/mp3player/mp3player.swf?src='.$fullurl.'">';
                echo '<param name="quality" value="high">';
                echo '<param name="bgcolor" value="#333333">';
                echo '<param name="flashvars" value="'.$c.'&amp;" />';
                echo '<embed src="'.$CFG->wwwroot.'/lib/mp3player/mp3player.swf?src='.$fullurl.'" ';
                echo ' quality="high" bgcolor="#333333" width="600" height="70" name="mp3player" ';
                echo ' type="application/x-shockwave-flash" ';
                echo ' flashvars="'.$c.'&amp;" ';
                echo ' pluginspage="http://www.macromedia.com/go/getflashplayer">';
                echo '</embed>';
                echo '</object>';
                echo '</div>';


            } else if ($resourcetype == "mediaplayer") {
                echo "<center><p>";
                echo '<object classid="CLSID:22D6f312-B0F6-11D0-94AB-0080C74C7E95"';
                echo '        codebase="http://activex.microsoft.com/activex/controls/mplayer/en/nsmp2inf.cab#Version=5,1,52,701" ';
                echo '        standby="Loading Microsoft? Windows? Media Player components..." ';
                echo '        id="msplayer" align="" type="application/x-oleobject">';
                echo "<param name=\"Filename\" value=\"$fullurl\">";
                echo '<param name="ShowControls" value="true" />';
                echo '<param name="AutoRewind" value="true" />';
                echo '<param name="AutoStart" value="true" />';
                echo '<param name="Autosize" value="true" />';
                echo '<param name="EnableContextMenu" value="true" />';
                echo '<param name="TransparentAtStart" value="false" />';
                echo '<param name="AnimationAtStart" value="false" />';
                echo '<param name="ShowGotoBar" value="false" />';
                echo '<param name="EnableFullScreenControls" value="true" />';
                echo "\n<embed src=\"$fullurl\" name=\"msplayer\" type=\"$mimetype\" ";
                echo ' ShowControls="1" AutoRewind="1" AutoStart="1" Autosize="0" EnableContextMenu="1"';
                echo ' TransparentAtStart="0" AnimationAtStart="0" ShowGotoBar="0" EnableFullScreenControls="1"';
                echo ' pluginspage="http://www.microsoft.com/Windows/Downloads/Contents/Products/MediaPlayer/">';
                echo '</embed>';
                echo '</object>';
                echo "</p></center>";

            } else if ($resourcetype == "quicktime") {

                echo "<center><p>";
                echo '<object classid="CLSID:02BF25D5-8C17-4B23-BC80-D3488ABDDC6B"';
                echo '        codebase="http://www.apple.com/qtactivex/qtplugin.cab" ';
                echo '        height="450" width="600"';
                echo '        id="quicktime" align="" type="application/x-oleobject">';
                echo "<param name=\"src\" value=\"$fullurl\" />";
                echo '<param name="autoplay" value="true" />';
                echo '<param name="loop" value="true" />';
                echo '<param name="controller" value="true" />';
                echo '<param name="scale" value="aspect" />';
                echo "\n<embed src=\"$fullurl\" name=\"quicktime\" type=\"$mimetype\" ";
                echo ' height="450" width="600" scale="aspect"';
                echo ' autoplay="true" controller="true" loop="true" ';
                echo ' pluginspage="http://quicktime.apple.com/">';
                echo '</embed>';
                echo '</object>';
                echo "</p></center>";
            }

            if (trim($resource->summary)) {
                $formatoptions->noclean = true;
                print_simple_box(format_text($resource->summary, FORMAT_MOODLE, $formatoptions, $course->id), "center");
            }

            if ($inpopup) {
                echo "<center><p>(<a href=\"$fullurl\">$strdirectlink</a>)</p></center>";
            } else {
                print_spacer(20,20);
                print_footer($course);
            }

        } else {              // Display the resource on it's own
            if (!empty($localpath)) {   // Show a link to help work around browser security
                echo '<div align="right" class="helplink">';
                link_to_popup_window ('/mod/resource/type/file/localpath.php', get_string('localfile', 'resource'), get_string('localfilehelp','resource'), 400, 500, get_string('localfilehelp', 'resource'));
                echo '</div>';
                echo "<center><p>(<a href=\"$fullurl\">$fullurl</a>)</p></center>";
            }
            redirect($fullurl);
        }


        //tree
        } else if ($refertype == 'tree') {
	    // check resource->id

	    if (!empty($rsid)) {
	        $ref = get_record("resource","id",$rsid);
	        $refcm = $_GET['id'];
	    } else {
	        $refcm = $_GET['id'];
		$rcm = get_record("course_modules","id",$refcm);
		$rrs = get_record("resource","id",$rcm->instance);
	        $ref = get_record("resource","id",$rrs->reference);
	    }

            /// Are we displaying the course blocks?
            if ((!trim(@$_GET['treeid']) == "") && isset($_GET['bk'])) {
                $treeid = $_GET['treeid'];
            } elseif (trim(@$_GET['treeid']) == "") {
                //refer
	        $rsmo = get_record("modules","name","resource");
	        $rcm = get_record("course_modules","instance",$ref->id,"module",$rsmo->id);
	
	        $treeid = $rcm->id;
            } else {
                //refer
	        $trcm = get_record("course_modules","instance",$ref->id);
	        $treeid = $_GET['treeid'].":".$trcm->id;
            }
            $pos = strpos($treeid, ":");
            if (!$pos === FALSE) {
                $treeidary = explode(":", $treeid);
	        $i = 1;
	        $num = count($treeidary);
	        foreach ($treeidary as $cmid) {
	            if (is_numeric($cmid)) {
	                $cm = get_record('course_modules', 'id', trim($cmid));
		        $rs = get_record('resource', 'id', $cm->instance);
		        if ($i == 1) {
		            $tidary[] = $cmid;
		            $this->navigation .= "<a href=\"$CFG->wwwroot/mod/resource/view.php?id=$refcm\">$rs->name</a> ->";
		        } elseif($num > $i) {
		            $tidary[] = $cmid;
		            $tidstr = implode(":", $tidary);
		            $this->navigation .= "<a href=\"$CFG->wwwroot/mod/resource/view.php?id=$refcm&amp;treeid=$tidstr&amp;bk=1&rsid=$rs->id\">$rs->name</a> ->";
		        }
	            }
	            $i++;
	        } 
            }

            if ($this->resource->options == 'showblocks') {
                parent::display_course_blocks_start3();
                $formatoptions->noclean = true;
	        $ref->alltext = htmlspecialchars_decode($ref->alltext, ENT_QUOTES);
	        $alltextary = explode("<!-- id -->", $ref->alltext);
                if (count($alltextary) > 1) {
		    if (!trim($alltextary[0]) == "") {
                        @$viewhtml = format_text($alltextary[0]."<br />", FORMAT_HTML, $formatoptions, $course->id);
                    } else {
                        @$viewhtml = format_text($alltextary[0], FORMAT_HTML, $formatoptions, $course->id);
		    }
                    $idsary = explode(":", $alltextary[1]);
 	            foreach ($idsary as $key => $val) {
	                if (is_numeric($val)) {
	                    $cmo = get_record("course_modules", "id", trim($val));
		            $res = get_record("resource", "id", $cmo->instance);
		            if (! trim($res->name) == "" && trim($cmo->visible) == 1) { 
			        if (trim($alltextary[0]) == "" && $key == 0) {
			            $atab = "<a href='".$CFG->wwwroot."/mod/resource/view.php?id=".$refcm."&amp;treeid=".$treeid."&rsid=".$res->id."'>".$res->name."</a><br />";
			        } else {
			            $atab = "<br /><a href='".$CFG->wwwroot."/mod/resource/view.php?id=".$refcm."&amp;treeid=".$treeid."&rsid=".$res->id."'>".$res->name."</a><br />";
				}
				$viewhtml .= format_text($atab, FORMAT_HTML, $formatoptions, $refcm);
		            } elseif (trim($cmo->visible) == 1) {
		                $res->alltext = htmlspecialchars_decode($res->alltext, ENT_QUOTES);
		                $alltext = explode("<!-- id -->", $res->alltext);
		                if (!is_null($alltext[0])) {
			            $viewhtml .= format_text("<br />".$alltext[0]."<br />", FORMAT_HTML, $formatoptions, $refcm);
		                }
		            }
	                }
	            }
                    echo format_text($viewhtml, FORMAT_HTML, $formatoptions, $this->course->id);
                } else {
                    echo format_text($viewhtml, FORMAT_HTML, $formatoptions, $this->course->id);
                }

                parent::display_course_blocks_end();

            } else {
                /// Set up generic stuff first, including checking for access
                parent::display();

                /// Set up some shorthand variables
                $cm = $this->cm;     
                $course = $this->course;
	        $resource = $this->resource;
	        $pagetitle = strip_tags($course->shortname.': '.format_string($ref->name));
                $formatoptions->noclean = true;
                $inpopup_param = optional_param( 'inpopup','' );
                $inpopup = !empty($inpopup_param);

	        if ($text = str_replace("/file.php/","/mod/resource/type/ref/refer_file.php/",$ref->alltext)){
                    $ref->alltext = $text;
                }

                if ($resource->popup) {
                    if ($inpopup) {                    /// Popup only
		        add_to_log($course->id, "resource", "view", "view.php?id={$refcm}", $resource->id, $cm->id);
                        print_header();
		        $ref->alltext = htmlspecialchars_decode($ref->alltext, ENT_QUOTES);
		        $alltextary = explode("<!-- id -->", $ref->alltext);
                        if (count($alltextary) > 1) {
			    if (!trim($alltextary[0]) == "") {
                                $viewhtml = format_text($alltextary[0]."<br />", FORMAT_HTML, $formatoptions, $course->id);
                            } else {
                                $viewhtml = format_text($alltextary[0], FORMAT_HTML, $formatoptions, $course->id);
			    }
	                    $idsary = explode(":", $alltextary[1]);
   		            foreach ($idsary as $key => $val) {
		                if (is_numeric($val)) {
		                    $cmo = get_record("course_modules", "id", trim($val));
			            $res = get_record("resource", "id", $cmo->instance);
			            if (! trim($res->name) == "" && trim($cmo->visible) == 1) { 
                                        if (isset($_GET["treeid"])) {
				            $treeid = $_GET["treeid"];
				        } else {
					    $rsmo = get_record("modules","name","resource");
	                                    $rcm = get_record("course_modules","instance",$ref->id,"module",$rsmo->id);
	                                    $treeid = $rcm->id;
				        }
					if (trim($alltextary[0]) == "" && $key == 0) {
				            $atab = "<a href='".$CFG->wwwroot."/mod/resource/view.php?id=".$cm->id."&amp;treeid=".$treeid."&rsid=".$res->id."'>".$res->name."</a><br />";
					} else {
				            $atab = "<br /><a href='".$CFG->wwwroot."/mod/resource/view.php?id=".$cm->id."&amp;treeid=".$treeid."&rsid=".$res->id."'>".$res->name."</a><br />";
					}
				        $viewhtml .= format_text($atab, FORMAT_HTML, $formatoptions, $refcm);
			            } elseif (trim($cmo->visible) == 1) {
				        $alltext = explode("<!-- id -->", htmlspecialchars_decode($res->alltext, ENT_QUOTES));
			                if (!is_null($alltext[0])) {
				            $viewhtml .= format_text("<br />".$alltext[0]."<br />", FORMAT_HTML, $formatoptions, $refcm);
			                }
			            }
		                }
		            }
		            print_simple_box($viewhtml, "center", "", "", "20");

                        } else {
		            print_simple_box(format_text($ref->alltext, FORMAT_HTML, $formatoptions, $course->id), "center", "", "", "20");
	                }
                        print_footer($course);

                    } else {                           /// Make a page and a pop-up window
		        print_header($pagetitle, $course->fullname, "$this->navigation ".format_string($ref->name), 
                                "", "", true, update_module_button($cm->id, $course->id, $this->strresource), 
                                navmenu($course, $cm));
                        @$treeid = $_GET["treeid"];
                        echo "\n<script language=\"javascript\" type=\"text/javascript\">";
                        echo "\n<!--\n";
		        echo "openpopup('/mod/resource/view.php?inpopup=true&treeid={$treeid}&id={$cm->id}&rsid={$ref->id}','resource{$resource->id}','{$resource->popup}');\n";
                        echo "\n-->\n";
                        echo '</script>';

                        if (trim(strip_tags($resource->summary))) {
                            print_simple_box(format_text($resource->summary, FORMAT_MOODLE, $formatoptions, $course->id), "center");
                        }
		        //refer
		        $tid = $_GET['rsid'];
		        $tcmid = get_record("course_modules","instance",$tid,"module",$rsmo->id);
		        @$treeid2 = $_GET['treeid'].":".$tcmid->id;
                        $link = "<a href=\"$CFG->wwwroot/mod/resource/view.php?inpopup=true&amp;id={$cm->id}&amp;treeid=$treeid\" target=\"resource{$resource->id}\" onclick=\"return openpopup('/mod/resource/view.php?inpopup=true&amp;id={$cm->id}&amp;treeid={$treeid2}&rsid={$tid}', 'resource{$resource->id}','{$resource->popup}');\">".format_string($resource->name,true)."</a>";
                        echo "<p>&nbsp;</p>";
                        echo '<p align="center">';
                        print_string('popupresource', 'resource');
                        echo '<br />';
                        print_string('popupresourcelink', 'resource', $link);
                        echo "</p>";
                        print_footer($course);
                    }
                } else {    /// not a popup at all

                    add_to_log($course->id, "resource", "view", "view.php?id={$cm->id}", $resource->id, $cm->id);
	            print_header($pagetitle, $course->fullname,  "$this->navigation ".format_string($ref->name),
                            "", "", true, update_module_button($cm->id, $course->id, $this->strresource), 
                            navmenu($course, $cm));
	            $ref->alltext = htmlspecialchars_decode($ref->alltext, ENT_QUOTES);
	            $alltextary = explode("<!-- id -->", $ref->alltext);
                    if (count($alltextary) > 1) {
		        if (!trim($alltextary[0]) == "") {
                            $viewhtml = format_text($alltextary[0]."<br />", FORMAT_HTML, $formatoptions, $course->id);
	                } else {
                            $viewhtml = format_text($alltextary[0], FORMAT_HTML, $formatoptions, $course->id);
			}
			$idsary = explode(":", $alltextary[1]);
		        foreach ($idsary as $key => $val) {
		            if (is_numeric($val)) {
		                $cmo = get_record("course_modules", "id", trim($val));
			        $res = get_record("resource", "id", $cmo->instance);
			        if (! trim($res->name) == "" && trim($cmo->visible) == 1) { 
				    if (trim($alltextary[0]) == "" && $key == 0) {
			                $atab = "<a href='".$CFG->wwwroot."/mod/resource/view.php?id=".$this->cm->id."&amp;treeid=".$treeid."&rsid=".$res->id."'>".$res->name."</a><br />";
				    } else {
			                $atab = "<br /><a href='".$CFG->wwwroot."/mod/resource/view.php?id=".$this->cm->id."&amp;treeid=".$treeid."&rsid=".$res->id."'>".$res->name."</a><br />";
				    }
			            $viewhtml .= format_text($atab, FORMAT_HTML, $formatoptions, $refcm);
			        } elseif (trim($cmo->visible) == 1) {
			            $ref->alltext = htmlspecialchars_decode($ref->alltext, ENT_QUOTES);
				    $alltext = explode("<!-- id -->", htmlspecialchars_decode($res->alltext, ENT_QUOTES));
			            if (!is_null($alltext[0])) {
				        $viewhtml .= format_text("<br />".$alltext[0]."<br />", FORMAT_HTML, $formatoptions, $refcm);
			            }
			        }
		            }
		
		        }
		        print_simple_box($viewhtml, "center", "", "", "20");
		
	            } else {
		        print_simple_box(format_text($ref->alltext, FORMAT_HTML, $formatoptions, $course->id), "center", "", "", "20");
	            }

                    $strlastmodified = get_string("lastmodified");
                    echo "<center><p><font size=\"1\">$strlastmodified: ".userdate($resource->timemodified)."</font></p></center>";
                    print_footer($course);
                }
            }
        }
    }


function setup($form) {
    $formtype = $form->type;
    if (!$form->mode) {
        $form->mode = '';
    }
    
    if ($formtype == 'ref' && $form->mode == 'add') {
        global $CFG;
        $id       = $form->course;
        $section  = $form->section;
        $sesskey  = $form->sesskey;
    
        redirect($CFG->wwwroot.'/mod/resource/type/ref/import.php?id='.$id.'&section='.$section.'&sesskey='.$sesskey,'',0);
    } else if ($form->mode == 'update') {
	
	//ȉhtml,textresource.class.php setupRs[@2008/2/14
        global $CFG, $editorfields, $RESOURCE_WINDOW_OPTIONS, $usehtmleditor;

        $editorfields = 'summary';

        if (! empty($form->course)) {
            if (! $this->course = get_record("course", "id", $form->course)) {
                error("Course is misconfigured");
            }
        }

        if (empty($form->name)) {
            $form->name = "";
        }
        if (empty($form->type)) {
            $form->type = "";
        }
        if (empty($form->summary)) {
            $form->summary = "";
        }
        if (empty($form->reference)) {
            $form->reference = "";
        }
        if (empty($form->alltext)) {
            $form->alltext = "";
        }
        if (empty($form->options)) {
            $form->options = "";
        }
        $nohtmleditorneeded = true;

        print_heading_with_help(get_string("resourcetype$form->type", 'resource'), $form->type, 'resource/type');

        include("$CFG->dirroot/mod/resource/type/ref/common.html");



        $strfilename = get_string("filename", "resource");
        $strnote     = get_string("note", "resource");
        $strchooseafile = get_string("chooseafile", "resource");
        $strnewwindow     = get_string("newwindow", "resource");
        $strnewwindowopen = get_string("newwindowopen", "resource");
        $strsearch        = get_string("searchweb", "resource");

        foreach ($RESOURCE_WINDOW_OPTIONS as $optionname) {
            $stringname = "str$optionname";
            $$stringname = get_string("new$optionname", "resource");
            $window->$optionname = "";
            $jsoption[] = "\"$optionname\"";
        }
    
        $blockoption = "\"blockdisplay\"";
        $popupoptions = implode(",", $jsoption);
        $jsoption[] = $blockoption;
        $alloptions = implode(",", $jsoption);

        if ($form->instance) {     // Re-editing
            if (!$form->popup) {
                $windowtype = "page";   // No popup text => in page
                foreach ($RESOURCE_WINDOW_OPTIONS as $optionname) {
                    $defaultvalue = "resource_popup$optionname";
                    $window->$optionname = $CFG->$defaultvalue;
                }
            } else {
                $windowtype = "popup";
                $rawoptions = explode(',', $form->popup);
                foreach ($rawoptions as $rawoption) {
                    $option = explode('=', trim($rawoption));
                    $optionname = $option[0];
                    $optionvalue = $option[1];
                    if ($optionname == "height" or $optionname == "width") {
                        $window->$optionname = $optionvalue;
                    } else if ($optionvalue) {
                        $window->$optionname = 'checked="checked"';
                    }
                }
            }
        } else {
            foreach ($RESOURCE_WINDOW_OPTIONS as $optionname) {
                $defaultvalue = "resource_popup$optionname";
            
                if ($optionname == "height" or $optionname == "width") {
                    $window->$optionname = $CFG->$defaultvalue;
                } else if ($CFG->$defaultvalue) {
                    $window->$optionname = 'checked="checked"';
                }
            }

            $windowtype = ($CFG->resource_popup) ? 'popup' : 'page';
            if (!isset($form->options)) {
                $form->options = '';
            }
        }
        
        include("$CFG->dirroot/mod/resource/type/ref/html.html");

        parent::setup_end();
    
    }
}

// file
//backwards compatible with existing resources
function set_encrypted_parameter() {
    global $CFG;

    if (!empty($this->refertext->reference) && file_exists($CFG->dirroot ."/mod/resource/type/file/externserverfile.php")) {
        include $CFG->dirroot ."/mod/resource/type/file/externserverfile.php";
        if (function_exists(extern_server_file)) {
            return extern_server_file($this->refertext->reference);
        }
    }
    return md5($_SERVER['REMOTE_ADDR'].$CFG->resource_secretphrase);
}

}
?>
